<template>
  <div class="form-container p-4">
    <div class="form-head d-flex align-items-center">
      <img src="@/assets/img/profile-img.png" alt="Profile Image" />
      <div class="ms-3">
        <h4 class="fw-bold">Welcome back</h4>
        <h6 class="fw-bold">{{ currentUser.name }}</h6>
      </div>
    </div>
    <div class="progress my-4" style="height: 3px">
      <div
        class="progress-bar bg-primary"
        role="progressbar"
        style="width: 45%"
      ></div>
    </div>
    <div class="form-meta mb-3">
      <h4 class="fw-bold">Reset Transaction</h4>
      <p class="fw-bold">Enter New Pin</p>
    </div>
    <form @submit.prevent="submitForm()">
      <div class="form-input mt-3">
        <p class="text-muted fw-bold">New Pin</p>
        <PincodeInput
          v-model="form.newTransactionPin"
          placeholder="0"
          :secure="true"
          :preview-duration="0"
          :character-preview="false"
        />
      </div>
      <div class="form-input mt-3">
        <p class="text-muted fw-bold">Confirm Pin</p>
        <PincodeInput
          v-model="form.confirmNewTransactionPin"
          placeholder="0"
          :secure="true"
          :preview-duration="0"
          :character-preview="false"
        />
      </div>

      <div class="mt-5">
        <vs-button type="submit" circle block :loading="form.active">
          Submit
        </vs-button>
      </div>
    </form>
  </div>
</template>

<script>
import PincodeInput from 'vue-pincode-input'

export default {
  components: {
    PincodeInput,
  },
  layout: 'auth',
  data: () => ({
    currentUser: { name: 'User' },
    active: false,
    form: {
      active: false,
      newTransactionPin: '',
      confirmNewTransactionPin: '',
      loading: false,
    },
  }),
  methods: {
    openNotification(position = null, color, message) {
      this.$vs.notification({
        progress: 'auto',
        color,
        position,
        title: message,
        text: '',
      })
    },
    submitForm() {
      if (!this.form.newTransactionPin || !this.form.confirmNewTransactionPin) {
        this.openNotification('top-left', 'warning', 'All Fields are required ')
        return
      }

      if (
        this.form.newTransactionPin !== this.form.confirmNewTransactionPin ||
        this.form.newTransactionPin.length !== 4 ||
        this.form.confirmNewTransactionPin.length !== 4
      ) {
        this.openNotification('top-left', 'warning', 'Pins donts match')
        return
      }

      this.form.active = true
      const data = {
        ...this.form,
      }
      this.$axios
        .$patch('/transaction/reset/pin', data)
        .then((response) => {
          this.form.active = false
          this.openNotification('top-left', 'success', response.message)
          this.$router.push('/auth/login')
        })
        .catch((error) => {
          this.form.active = false
          if (
            error.response.status === 404 ||
            error.response.status === 400 ||
            error.response.status === 401 ||
            error.response.status === 403 ||
            error.response.status === 406
          ) {
            // console.log(error.response.data.message)
            this.openNotification(
              'top-left',
              'danger',
              error.response.data.message
            )
          }
        })
    },
  },
}
</script>

<style lang="scss" scoped>
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';

.vue-pincode-input {
  max-width: 45px !important;
  height: 50px;
  left: 468px;
  top: 729px;
  background: #f0f2f2;
  /* opacity: 0.08; */
  border-radius: 10px !important;
  box-shadow: none !important;
}
.form-input {
  input,
  select {
    border: none;
    background: transparent;
    border-radius: 0;
    border-bottom: 1px solid $dark;
    padding: 15px 0;

    min-width: 52px;

    box-shadow: none;
    &:focus {
      box-shadow: none;
      border-bottom: 1px solid $primary;
    }
  }
}
</style>
